/***********************************************************************
This program reads data from a file and stores the data in a linked list
in key sequence.  The program then allows the suer to add data to the
list, delete data from the list, and search the list.
Name: Long Nguyen
CIS 15BG
LAB: 7 Final
Data: 3/16/05
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int getchoice(void);
Node * makeList(void);
int searchList(Node * pList, Node **pPre, Node **pCur, KEY_TYPE target);
Node * insert (Node * pList, Node * pPre, Node * pCur, Node * pNew);
Node * del (Node * pList, Node * pPre, Node * pCur);
void printList (Node * pList);

typedef int KEY_TYPE;

typedef struct
{
	KEY_TYPE key;
}Data;

typedef struct node
{
	Data data;
	struct node *link;
	char city[NAME_LENGTH];
	char country[NAME_LENGTH];


}Node;

int main(void)
{
	Node * pList;
	char name[50];
	Node * pNew;
	int choice c;

	// prompt for filename, read from file, create list, then print list
	pList = makeList();
	printList (pList);

	// print menu, get user choice
	c = getchoice();  
	while (c != 3)
	{
		switch (c)
		{
		case 1:
			fflush(stdin);
			while (getchar() !='\n');  // flush input stream
			printf ("\nEnter name to search: ");
			scanf ("%[^\n]", name);
			searchList (pList, name);  // print found data or error msg
			if(c == NULL)
				printf("Data not found");
			break;
		case 2:
			while (getchar() !='\n');
			printf ("Enter name to delete: ");
			scanf ("%[^\n]", name);
			// delete node with user input name, if it's in the list
			pList = delList (pList, name);   
			printf ("Delete done. Here is the updated list\n");
			printList (pList);
			break;
		default:
			printf ("Enter 1 - 3 only\n");
		}
		c = getchoice();
	}

	pList = destroyList(pList);
	return 0;
}


Node * makeList(void)
{
	char name[50];
	char line[50];
	Node * pList = NULL; 
	Node * pPre = NULL; 
	Node * pCur = NULL; 
	Node * pNew = NULL;

	printf("Enter file name: ");
	gets(name);
	FILE* fp = fopen(name, "r");
	if (fp == NULL)
	{
		printf("FILE NOT FOUND...");
		exit(1);
	}
	while(fscanf(fp, "%[A-Za-z, ]%*c", line) != EOF)
	{

	pList = makeList(Node*)malloc(sizeof(Node));
		if (pNew == NULL)
		{
			printf("ERROR...\n");
			exit(1);
		}
		*pNew = pList;
		pNew -> link = NULL;
	
	}
	fclose(fp); 
}

// getchoice: prints menu and asks for choice
// input: nothing
// return: integer choice
int getchoice(void)
{
	int choice;

	printf ("\n");
	printf ("1. Search\n");
	printf ("2. Delete\n");
	printf ("3. Quit\n");
	printf ("Enter choice [1-3]: ");
	scanf ("%d", &choice);

	return choice;
}

// insert: adds a node to the list
// input: plist - ptr to beginning of list
//        pPre, pCur, pNew - ptr to one node each
//            pNew's node is to be inserted between pPre's node and pCur's node
// return: plist - ptr to updated list
Node * insert (Node * pList, Node * pPre, Node * pCur, Node * pNew)
{
	Node * pNew;
	if(!(pNew = (Node*)malloc(sizeof(Node))))
		printf("\aMemory overflow in insert\n");
	exit(100);
	
	if (pPre == NULL)  // insert at beginning
		pNew->link = pList;
		pList = pNew;
	else
		pPre->link = pNew;  // insert at middle or end
	pNew->link = pCur;
	pCur->link = pNew
	return pList;
}


int searchList(Node * pList, Node **pPre, Node **pCur, KEY_TYPE target)
{
	int found = 0;

	*pPre = NULL;
	*pCur = pList;

	while(*pCur != NULL && target > (*pCur)->data.key)
	{
		*pPre = *pCur;
		*pCur = (*pCur)->link;
	}
	if(*pCur && target == (*pCur)->data.key)
		found = 1;
	return found;
}



// del: deletes a node from the list
// input: plist - ptr to beginning of list
//        pPre, pCur - ptr to one node each
//            pCur's node is to be deleted, pPre's node is in front of pCur's node
// return: plist - ptr to updated list
Node * del (Node * pList, Node * pPre, Node * pCur)
{
	if (pPre == NULL)	// delete at beginning
		pList = pCur->link;
	else
		pPre->link = pCur->link;   // delete at middle or end
	free (pCur);
	return pList;
}

// printList: prints the data in the list
// input: pList - ptr to beginning of list
// return: nothing
void printList (Node *pList)
{
	Node * pWalker = pList;
	int lineCount = 0;

	if (!pList) //empty list
		return;

	printf ("\n");
	while (pWalker != NULL)
	{
		//add statement to print data of one node here
		//   ...
		pwalker = pList;
		printf("\nList contains:\n");
		while(pWalker)
		{
			if(++lineCount > 10)
			{
				lineCount = 1;
				printf("\n");
			}
			printf("%3d ", pWalker>data.key);
		pWalker = pWalker->link;
	}
		printf("\n");
		return;
}
